DEVICE_GET_SOFTC(9)

NAME
device_get_softc - access driver private instance variables

SYNOPSIS
#include <sys/param.h>
#include <sys/bus.h>
void *
device_get_softc(device_t dev);

DESCRIPTION
Return the driver-specific state of dev. The softc is automatically allocated and zeroed when the device is attached. The softc is also initialized and present when a device is probed, but is subject to caveats as described in DEVICE_PROBE(9). The size of the allocation is determined by the device's driver_t information used to define the driver. The softc typically encapsulates the state of this instance of the device.

Driver writers are discouraged from using their own softc management mechanisms. Driver writers should not copy such mechanisms found in drivers in the tree that predate this function.

RETURN VALUES
The pointer to the driver-specific instance variable is returned.

SEE ALSO
device(9), DEVICE_PROBE(9), device_set_softc(9), driver(9)

AUTHORS
This manual page was written by Doug Rabson.